%if 0%{?rhel} && 0%{?rhel} <= 7
%bcond_with python3
%else
%bcond_without python3
%endif

%global modname parse_type

Name:           python-%{modname}
Version:        0.3.4
Release:        11%{?dist}
Summary:        Simplifies to build parse types based on the parse module

License:        BSD
URL:            http://pypi.python.org/pypi/parse_type
Source0:        http://pypi.python.org/packages/source/p/%{modname}/%{modname}-%{version}.tar.gz
Patch0:         parse_type-build.patch
# https://github.com/jenisys/parse_type/pull/4
Patch1:         python-parse_type-0.3.4-fix-parse-test.patch

BuildArch:      noarch

%global _description \
"parse_type" extends the "parse" module (opposite of\
"string.format()") with the following features:\
* build type converters for common use cases (enum/mapping, choice)\
* build a type converter with a cardinality constraint (0..1,\
  0..*, 1..*) from the type converter with cardinality=1.\
* compose a type converter from other type converters\
* an extended parser that supports the CardinalityField naming\
  schema and creates missing type variants (0..1, 0..*, 1..*) from\
  the primary type converter

%description %{_description}

%package -n python2-%{modname}
Summary:        %{summary}
%{?python_provide:%python_provide python2-%{modname}}
BuildRequires:  python2-devel
BuildRequires:  python2-setuptools
BuildRequires:  python2-six
BuildRequires:  python2-parse >= 1.6
BuildRequires:  python-enum34
BuildRequires:  python-sphinx >= 1.1
Requires:       python2-six
Requires:       python2-parse
Requires:       python-enum34

%description -n python2-%{modname} %{_description}

Python 2 version.

%if %{with python3}
%package -n python3-%{modname}
Summary:        %{summary}
%{?python_provide:%python_provide python3-%{modname}}
BuildRequires:  python3-devel
BuildRequires:  python3-setuptools
BuildRequires:  python3-six
BuildRequires:  python3-parse
BuildRequires:  python3-sphinx >= 1.1
Requires:       python3-six
Requires:       python3-parse

%description -n python3-%{modname} %{_description}

Python 3 version.
%endif

%prep
%setup -q -c
mv %{modname}-%{version} python2
pushd python2
rm -vrf *.egg-info
%patch0 -p1
%patch1 -p1
popd
%if %{with python3}
cp -ai python2 python3
%endif

%build
pushd python2
  %py2_build
popd
%if %{with python3}
pushd python3
  %py3_build
popd
%endif

%install
export PYSETUP_TEST="no"
pushd python2
  %py2_install
popd
%if %{with python3}
pushd python3
  %py3_install
popd
%endif

%check
pushd python2
  %{__python2} setup.py test
popd
%if %{with python3}
pushd python3
  %{__python3} setup.py test
popd
%endif

%files -n python2-%{modname}
%license python2/LICENSE
%doc python2/README.rst
%{python2_sitelib}/%{modname}-%{version}-*.egg-info/
%{python2_sitelib}/%{modname}/
%{python2_sitelib}/_paver_ext/

%if %{with python3}
%files -n python3-%{modname}
%license python3/LICENSE
%doc python3/README.rst
%{python3_sitelib}/%{modname}-%{version}-*.egg-info/
%{python3_sitelib}/%{modname}/
%{python3_sitelib}/_paver_ext/
%endif

%changelog
* Tue Jul 19 2016 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 0.3.4-11
- https://fedoraproject.org/wiki/Changes/Automatic_Provides_for_Python_RPM_Packages

* Mon May 09 2016 Igor Gnatenko <ignatenko@redhat.com> - 0.3.4-10
- Correctly do Provides/Obsoletes

* Sun May  8 2016 Peter Robinson <pbrobinson@fedoraproject.org> 0.3.4-9
- Provide/Obsolete python-parse_type for upgrade paths

* Tue Apr 19 2016 Igor Gnatenko <ignatenko@redhat.com> - 0.3.4-8
- Use %%license
- Use %%python_provide
- Don't use splitted dirs
- Correctly split python2- subpkg
- Other cleanups/fixes

* Thu Feb 04 2016 Fedora Release Engineering <releng@fedoraproject.org> - 0.3.4-7
- Rebuilt for https://fedoraproject.org/wiki/Fedora_24_Mass_Rebuild

* Wed Dec 16 2015 Matěj Cepl <mcepl@redhat.com> - 0.3.4-6
- Whoops! Duplicated BuildRequires and Requires removed.

* Tue Dec 15 2015 Matěj Cepl <mcepl@redhat.com> - 0.3.4-5
- Remove unnecessary dependency on python-enum34 for python3 (#1286457)

* Tue Nov 10 2015 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 0.3.4-4
- Rebuilt for https://fedoraproject.org/wiki/Changes/python3.5

* Thu Jun 18 2015 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 0.3.4-3
- Rebuilt for https://fedoraproject.org/wiki/Fedora_23_Mass_Rebuild

* Thu Jun 19 2014 Matěj Cepl <mcepl@redhat.com> - 0.3.4-1
- initial package for Fedora
